
;**************************************
;     SOFTWARE FOR CP - JR180 PLUS    *
;              DISPLAY 8*20           *
;           EXAMPLE PROGRAM 06        *
;**************************************
;

           CPU "64180.TBL"
           HOF "INT8"

           ORG 8000H

PSCAN:     EQU  8DH
DATA:      EQU  8CH
CLK:       EQU  8EH
CTRL:      EQU  8FH
NDSP:      EQU  8
BLOCK:     EQU  24*NDSP
TIME1:     EQU  9DH
TCR:       EQU  10H
TMDR1L:    EQU  14H
DCNTL:     EQU  32H
TXSTG:     EQU  85H
RTEXT:     EQU  86H
SYSCAL:    EQU  10H
;
;
;***********************
;     MAIN PROGRAM     *
;***********************

MAIN:   DI
        LD   A,0
        OUT0 (DCNTL),A
;
        LD   A,TXSTG
        RST  SYSCAL
        DFB  "WAIT FOR LOAD TEXT FILE",0DH,0AH,0
        LD   HL,CHAR
        LD   A,RTEXT
        RST  SYSCAL
;
        LD   BC,BLOCK       ;Clear buffer character
        LD   HL,DISBUF
        LD   DE,DISBUF+1
        LD   (HL),0
        LDIR
        CALL CLRDSP         ;Clear buffer screen
;
        LD   A,80H
        OUT  (CTRL),A
        LD   A,0FFH
        OUT  (CLK),A
;
        LD   A,TIME1
        LD   HL,12          ;200 US
        LD   B,0
        LD   DE,SCAND
        RST  SYSCAL
        LD   HL,TSL
        LD   (PSEL),HL
;
MAIN1:  LD   HL,CHAR
        LD   (B_IX),HL

MAIN2:  LD   HL,(B_IX)
        LD   A,(HL)
        CP   1AH
        JR   Z,MAIN1
;
        XOR  A
        LD   (F_1ST),A
        CALL ASC_MIX
        CALL MIR
        CALL CONV
        EI
        CALL SHTL           ;LED shift left
        DI
        JR   MAIN2
;
;***********************
; CHANGE ASCII TO FONT *
;***********************

ASC_MIX:
        LD   DE,DISBUF
        LD   IX,(B_IX)
        LD   HL,0
        LD   (CNUM),HL

ASC_M1: LD   A,(IX+0)
        CP   1AH
        JR   Z,ASC_ME1
;
        CP   0DH
        JR   Z,ASC_M2
        CP   0AH
        JR   Z,ASC_ME
;
        CP   0D7H
        JR   C,ASC_M3             ;NORMAL
        CP   0E5H+1
        JR   NC,ASC_M3            ;NORMAL
;
        SUB  20H
        LD   C,A
        CALL FIND
        CALL MIX                  ;MIX
ASC_M2: INC  IX
        JP   ASC_M1
;
;/* NORMAL */

ASC_M3: SUB  20H
        LD   C,A
        CALL FIND
        LD   A,(F_1ST)            ;
        OR   A
        LD   A,0FFH
        LD   (F_1ST),A
        JR   Z,ASC_M31            ;GO REAL
        CALL REAL
;
ASC_M31:
        PUSH DE
        LD   DE,B_MIX
        LD   BC,24
        LDIR
        POP  DE
        INC  IX
        JP   ASC_M1
;
ASC_ME: INC  IX
ASC_ME1:
        CALL REAL
        LD   (B_IX),IX
        RET
;
;***********************
;  CHR_MIX -> BUF_CHR  *
;***********************
; I/P = (HL)  ;B_MIX
; O/P = (DE)  ;DISBUF

REAL:   PUSH HL
        LD   HL,B_MIX
        LD   BC,24
        LDIR
        LD   HL,(CNUM)
        INC  HL
        LD   (CNUM),HL
        POP  HL
        RET
;
;***********************
;   MIX CHARACTER SUB. *
;***********************

MIX:    PUSH DE
        LD   B,24
        LD   DE,B_MIX
MIX1:   LD   A,(DE)
        OR   (HL)
        LD   (DE),A
        INC  HL
        INC  DE
        DJNZ MIX1
        POP  DE
        RET
;
;***********************
; FIND ADDRESS OF ASCII*
;***********************

FIND:   LD   HL,FONT
        LD   B,24
        MLT  BC
        ADD  HL,BC
        RET


;***********************
; DISPLAY LEFT & RIGHT *
;***********************
;
DSP_LR:
        LD   A,5
        LD   (LOOP),A
DSP_LR1:
        LD   A,(LOOP)
        DEC  A
        JR   NZ,DSP_LR1
        LD   A,5
        LD   (LOOP),A
        RET
;
;
;***********************
;      SCAN DISPLAY    *
;***********************

SCAND:  PUSH AF
        PUSH BC
        PUSH DE
        PUSH HL
;
;/* scan display 5 digit */

        IN0  A,(TCR)
        IN0  A,(TMDR1L)
;
        LD   HL,(PSEL)
        LD   A,0F0H
        CP   (HL)
        JR   NZ,SCAND1
;
        LD   A,8
        LD   (CNT1),A
        LD   HL,TSL
        LD   (PSEL),HL
        LD   HL,DISPY
        LD   DE,DISPY1
        LD   (DSP_INT),DE
        LD   BC,24*NDSP
        LDIR
;

SCAND1: CALL CLEAR
        LD   HL,(PSEL)
        LD   A,(HL)
        OUT  (PSCAN),A
        LD   HL,(DSP_INT)
;
        LD   D,NDSP
        LD   E,0
        LD   C,24
;
SCAND2: PUSH HL
        LD   B,8            ;8 bit of column is convert
SCAND3: RRC  (HL)           ;
        RRA                 ;data to convert
        INC  HL
        DJNZ SCAND3
;
        OUT  (DATA),A
        LD   A,E
        RLCA
        OUT  (CTRL),A
        OR   1
        OUT  (CTRL),A
        INC  E
;
        POP  HL
        ADD  HL,BC
        DEC  D
        JR   NZ,SCAND2
;
        LD   HL,(PSEL)
        INC  HL
        LD   (PSEL),HL
        LD   A,0F0H
        CP   (HL)
        JR   Z,SCAND4
;
        LD   A,(CNT1)
        DEC  A
        LD   (CNT1),A
        JR   NZ,SCAND5
        LD   A,8
        LD   (CNT1),A
;
        LD   BC,8
        LD   HL,(DSP_INT)
        ADD  HL,BC
        LD   (DSP_INT),HL
        JR   SCAND5
;
SCAND4: LD   HL,LOOP
        DEC  (HL)

SCAND5: POP  HL
        POP  DE
        POP  BC
        POP  AF
        EI
        RET
;
;***********************
;   74LS374 CLOCK SUB. *
;***********************

PULSE:  LD   A,E
        SLA  A
        OUT  (CTRL),A
        OR   1
        OUT  (CTRL),A
        RET

;
;***********************
;  CLEAR DATA 74LS374  *
;***********************

CLEAR:  LD   E,0
        LD   B,NDSP
;
CLEAR1: XOR  A               ;CLEAR
        OUT  (DATA),A
        CALL PULSE
        INC  E
        DJNZ CLEAR1
        RET
;
;***********************
;       DELAY SUB.     *
;***********************
;
DEL:    PUSH AF
        LD   A,20H
DEL1:   DEC  A
        JR   NZ,DEL1
        POP  AF
        RET
;
;***********************
;   CLEAR DISPLAY BUF  *
;***********************
;
CLRDSP: PUSH HL
        LD  HL,DISPY
        LD  BC,BLOCK
        LD  DE,DISPY+1
        LD  (HL),0
        LDIR
        POP  HL
        RET
;
;
;***********************
;   shift left display *
;***********************
;
SHTL:   CALL GLENT
        LD   IX,DISBUF

SHTL00: LD   A,8
        LD   (BUF_8),A

SHTL0:  LD   D,0
        LD   E,0
        LD   HL,8*NDSP       ;BLOCK
        OR   A
        SBC  HL,BC
        JP   NC,SHTL1
        LD   E,0FFH
        LD   D,(IX+0)
;
SHTL1:  LD   HL,DISPY+8-1

        PUSH BC
        PUSH IX

        CALL ROTATE
        LD   HL,DISPY+24+8-1
        CALL NEXT
        CALL SADD

        LD   A,E
        CP   0
        JR   NZ,SHTL2
        LD   D,0

SHTL2:  LD   HL,DISPY+16-1
        CALL ROTATE
;
        LD   HL,DISPY+24+16-1
        CALL NEXT
        CALL SADD

        LD   A,E
        CP   0
        JR   NZ,SHTL3
        LD   D,0

SHTL3:  LD   HL,DISPY+24-1
        CALL ROTATE

        LD   HL,DISPY+24+24-1
        CALL NEXT

        CALL DSP_LR

        POP  IX
        POP  BC

        INC  IX
        DEC  BC
        LD   A,B
        OR   C
        JR   Z,SHTLE
;
        LD   A,(BUF_8)
        DEC  A
        LD   (BUF_8),A
        JP   NZ,SHTL0
;
        PUSH IX
        POP  HL
        LD   DE,16
        ADD  HL,DE
        PUSH HL
        POP  IX
        JP   SHTL00

SHTLE:  RET
;
;***********************
;    ROTATE NEXT CHR.  *
;***********************

NEXT:   PUSH BC
        LD   B,NDSP-1
NEXT1:  PUSH HL
        CALL ROTATE
        POP  HL
        PUSH DE
        LD   DE,24
        ADD  HL,DE
        POP  DE
        DJNZ NEXT1
        POP  BC
        RET
;
;***********************
;     ROTATE 1 CHR.    *
;***********************

ROTATE:
        PUSH BC
        LD   B,8
ROTAT1: LD   A,(HL)
        LD   (HL),D
        LD   D,A
        DEC  HL
        DJNZ ROTAT1
        POP  BC
        RET
;
;***********************
;   NEXT DATA DISPLAY  *
;***********************

SADD:   PUSH HL
        PUSH IX
        POP  HL
        LD   A,L
        ADD  A,8
        LD   L,A
        LD   A,H
        ADC  A,0
        LD   H,A
        LD   D,(HL)

SADD1:  PUSH HL
        POP  IX
        POP  HL
        RET


;***********************
;       GET LENGTH     *
;***********************
;
GLENT:  LD   HL,(CNUM)
        ADD  HL,HL
        ADD  HL,HL
        ADD  HL,HL
        LD   DE,8*NDSP
        ADD  HL,DE
        PUSH HL
        POP  BC
        RET
;
;***********************
;      FONT CONVERT    *
;***********************
;
FONT_COV:
        PUSH IY
        PUSH DE
        PUSH AF

        LD   DE,CHR_BUF
        LD   BC,24
        LDIR
;
        LD   IY,CHR_BUF1
        LD   E,3

FONT_1:
        LD   HL,CHR_BUF
FONT_2: LD   B,8

FONT_3: PUSH HL
        LD   C,8

FONT_31:
        RRC  (HL)
        RR   D
        INC  HL
        DEC  C
        JR   NZ,FONT_31

        LD   (IY+0),D
        INC  IY

        POP  HL
        DEC  B
        JR   NZ,FONT_3
;
        LD   BC,8
        ADD  HL,BC
        DEC  E
        JR   NZ,FONT_2

        POP  AF
        POP  DE
        POP  IY
        LD   HL,CHR_BUF1
        RET
;
;
CONV:   LD   HL,DISBUF
        LD   DE,DISBUF
        LD   BC,(CNUM)              ;NUM OF CHARACTER
CONV1:  PUSH BC
        PUSH HL
        CALL FONT_COV
        LD   BC,24
        LDIR
;
        POP  HL
        LD   BC,24
        ADD  HL,BC
        POP  BC
        DEC  BC
        LD   A,B
        OR   C
        JR   NZ,CONV1
        RET
;
;***********************
;      MIRROR CHAR.    *
;***********************

MIR:    LD   HL,DISBUF
        LD   BC,(CNUM)
MIR1:   CALL MIR_S
        DEC  BC
        LD   A,B
        OR   C
        JR   NZ,MIR1
        RET
;
;***********************
;       MIRROR SUB.    *
;***********************

MIR_S:  PUSH BC
        LD   C,24
MIR_S0: LD   B,8
MIR_S1: RLC  (HL)
        RR   A
        DJNZ MIR_S1
        LD   (HL),A
        INC  HL
        DEC  C
        JR   NZ,MIR_S0
        POP  BC
        RET


TSL:     DFB   0F0H,0F1H,0F2H,0F3H,0F4H
         DFB   0F5H,0F6H,0F7H,0F8H,0F9H
         DFB   0FH,1FH,2FH,3FH,4FH
         DFB   5FH,6FH,7FH,8FH,9FH
         DFB   0F0H
;
FONT:
           INCL "FONTCU.HEX"


           ORG  9820H


DISPY:     DFS   BLOCK
DISPY1:    DFS   BLOCK
CHR_BUF:   DFS   24
CHR_BUF1:  DFS   24
CNT1:      DFS   1
PSEL:      DFS   2
LOOP:      DFS   1
BUF_8:     DFS   1
DSP_INT:   DFS   2
B_MIX:     DFS   24
F_1ST:     DFS   1
CNUM:      DFS   2
B_IX:      DFS   2
DISBUF:    DFS   24*120

           ORG   0A800H
CHAR:

           END








